commit 8d77d55d9e20c64c8c86f0d5d6956d5edea307af
Author: freddy77 <freddy77>
Date:   Thu Aug 7 07:18:51 2008 +0000

    use NTLMv2 if possible

diff --git a/ChangeLog b/ChangeLog
index 7e437fa..87c84c9 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Thu Aug 07 09:17:58 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/challenge.c: use NTLMv2 if possible
+
 Wed Aug 06 09:32:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/config.c src/tds/login.c src/tds/mem.c src/tds/token.c:
 	- keep packet size to safe values
@@ -508,4 +511,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2575 2008/08/06 07:40:10 freddy77 Exp $
+$Id: ChangeLog,v 1.2576 2008/08/07 07:18:51 freddy77 Exp $
diff --git a/src/tds/challenge.c b/src/tds/challenge.c
index 5476d16..a053d94 100644
--- a/src/tds/challenge.c
+++ b/src/tds/challenge.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: challenge.c,v 1.33 2008/07/31 14:57:02 freddy77 Exp $");
+TDS_RCSID(var, "$Id: challenge.c,v 1.34 2008/08/07 07:18:53 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -270,13 +270,35 @@ tds_answer_challenge(TDSSOCKET * tds,
 	static const des_cblock magic = { 0x4B, 0x47, 0x53, 0x21, 0x40, 0x23, 0x24, 0x25 };
 	DES_KEY ks;
 	unsigned char hash[24], ntlm2_challenge[16];
-	int ntlm_v, res;
+	int res;
 
 	memset(answer, 0, sizeof(TDSANSWER));
 
-	ntlm_v = 2;
+	if (!(*flags & 0x80000)) {
+		/* NTLM */
+		unsigned char passwd_buf[MAX_PW_SZ];
+
+		/* convert password to upper and pad to 14 chars */
+		memset(passwd_buf, 0, MAX_PW_SZ);
+		len = strlen(passwd);
+		if (len > MAX_PW_SZ)
+			len = MAX_PW_SZ;
+		for (i = 0; i < len; i++)
+			passwd_buf[i] = toupper((unsigned char) passwd[i]);
+
+		/* hash the first 7 characters */
+		tds_convert_key(passwd_buf, &ks);
+		tds_des_ecb_encrypt(&magic, sizeof(magic), &ks, (hash + 0));
 
-	if (ntlm_v == 2) {
+		/* hash the second 7 characters */
+		tds_convert_key(passwd_buf + 7, &ks);
+		tds_des_ecb_encrypt(&magic, sizeof(magic), &ks, (hash + 8));
+
+		memset(hash + 16, 0, 5);
+
+		tds_encrypt_answer(hash, challenge, answer->lm_resp);
+		memset(passwd_buf, 0, sizeof(passwd_buf));
+	} else if (names_blob_len > 0) {
 		/* NTLMv2 */
 		unsigned char *lm_v2_response;
 		unsigned char ntlm_v2_hash[16];
@@ -287,7 +309,7 @@ tds_answer_challenge(TDSSOCKET * tds,
 			return res;
 
 		/* LMv2 response */
-		/* Take client's chalenge from names_blob */
+		/* Take client's challenge from names_blob */
 		names_blob_prefix = (const names_blob_prefix_t *) names_blob;
 		lm_v2_response = make_lm_v2_response(ntlm_v2_hash, names_blob_prefix->challenge, 8, challenge);
 		if (!lm_v2_response)
@@ -302,36 +324,10 @@ tds_answer_challenge(TDSSOCKET * tds,
 			return TDS_FAIL;
 
 		return TDS_SUCCEED;
-	}
-
-	if (!(*flags & 0x80000)) {
-		/* NTLM */
-		unsigned char passwd_buf[MAX_PW_SZ];
-
-		/* convert password to upper and pad to 14 chars */
-		memset(passwd_buf, 0, MAX_PW_SZ);
-		len = strlen(passwd);
-		if (len > MAX_PW_SZ)
-			len = MAX_PW_SZ;
-		for (i = 0; i < len; i++)
-			passwd_buf[i] = toupper((unsigned char) passwd[i]);
-
-		/* hash the first 7 characters */
-		tds_convert_key(passwd_buf, &ks);
-		tds_des_ecb_encrypt(&magic, sizeof(magic), &ks, (hash + 0));
-
-		/* hash the second 7 characters */
-		tds_convert_key(passwd_buf + 7, &ks);
-		tds_des_ecb_encrypt(&magic, sizeof(magic), &ks, (hash + 8));
-
-		memset(hash + 16, 0, 5);
-
-		tds_encrypt_answer(hash, challenge, answer->lm_resp);
-		memset(passwd_buf, 0, sizeof(passwd_buf));
 	} else {
+		/* NTLM2 */
 		MD5_CTX md5_ctx;
 
-		/* NTLM2 */
 		generate_random_buffer(hash, 8);
 		memset(hash + 8, 0, 16);
 		memcpy(answer->lm_resp, hash, 24);

